Subject: Re: [PATCH v10.1 7/7] bisect: allow any terms set by user

From: Matthieu Moy <[email-masked]>
Date: Mon, 29 Jun 2015 17:19:21 +0200

Christian Couder <[email-masked]> writes:

> On Mon, Jun 29, 2015 at 11:32 AM, Matthieu Moy
> <[email-masked]> wrote:
>> bisect is all about finding the commit where a property has changed,
>
> That is your interpretation of this command. On the man page there is:
>
>     git-bisect - Find by binary search the change that introduced a bug
>
> So its stated purpose is to find the first "bad" commit. Not to find a fix.

This is a limitation of the current bisect, but the discussion is
precisely about removing this limitation.

I still don't understand what "risk" we are taking by doing the
bisection anyway. I can't imagine a case where we would harm the user by
doing so.

I just tested with Mercurial, and looking for a fix instead of a
regression just works:

$ hg bisect --good 4        
$ hg bisect --bad 1         
Testing changeset 2:d75a2d042c99 (3 changesets remaining, ~1 tests)
1 files updated, 0 files merged, 0 files removed, 0 files unresolved
$ hg bisect --bad  
Testing changeset 3:9d27d9c02e28 (2 changesets remaining, ~1 tests)
1 files updated, 0 files merged, 0 files removed, 0 files unresolved
$ hg bisect --bad
The first good revision is:
changeset:   4:1dd9bb959eb6
tag:         tip
user:        Matthieu Moy <[email-masked]>
date:        Mon Jun 29 17:07:51 2015 +0200
summary:     foo

I don't see anything wrong with this.

(OTOH, "hg bisect" does not accept revisions which aren't parent of each
other)

-- 
Matthieu Moy
http://www-verimag.imag.fr/~moy/